bool flag[2];    // initialized to 0
int critical;    // # of threads in CS, initialized to 0

active[2] proctype P() {
  // int _pid;      is an implicit variable holding the process' id

  // wait for other process to not be in CS
  do
  :: flag[1 - _pid] == 0 -> break;
  od;

  // since the other process is now not in CS, I can set my flag.
  flag[_pid] = 1;

  // enter CS
  critical ++;
  printf("%d is now in critical section. (%d)\n", _pid, critical);
  critical --;
  flag[_pid] = 0;
  // leave CS
}

// ltl { *** to do *** }